Subject: comp.windows.x Frequently Asked Questions (FAQ) 1/7
Newsgroups: comp.windows.x,news.answers,comp.answers

Archive-name: x-faq/part1
Last-modified: 1996/09/26

This article and several following contain the answers to some Frequently Asked 
Questions (FAQ) often seen in comp.windows.x. It is posted to help reduce 
volume in this newsgroup and to provide hard-to-find information of general 
interest.

		Please redistribute this article!

This article includes answers to the following questions, which are loosely
grouped into categories. Questions marked with a + indicate questions new to 
this issue; those with significant changes of content since the last issue are 
marked by !:

  0)  TOPIC: BASIC INFORMATION SOURCES AND DEFINITIONS
  1)  What books and articles on X are good for beginners?
  2)  What courses on X and various X toolkits are available?
  3)  What conferences on X are coming up?
  4)! What X-related public mailing lists are available?
  5)  How can I meet other X developers? (What X user groups are there?)
  6)  What related FAQs are available?
  7)  How do I ask a net-question so as to maximize helpful responses?
  8)! What publications discussing X are available?
  9)  What are these common abbreviations/acronyms?
 10)  What is the ICCCM? (How do I write X-friendly applications?)
 11)  What is the X Consortium, and how do I join?
 12)  Just what are OPEN LOOK and Motif?
 13)! What is "low-bandwidth X" (X.fast/LBX)? XRemote? PPP? SLIP? CSLIP?
 14)+ TOPIC: X CONSORTIUM FUTURES
 15)+ What's the official word from the X Consortium?
 16)+ What happens to X? to Broadway? still free?
 17)+ Why is this happening?
 18)+ Can X11R6.1 be a freeware base? Will future X versions be free?
 19)  TOPIC: USING X IN DAY-TO-DAY LIFE
 20)  What are all these window managers? (Where can I get a "virtual" wm?)
 21)  Why does my X session exit when I kill my window manager (sic)?
 22)  Can I save the state of my X session, like toolplaces does?
 23)  How do I use another window manager with DEC's session manager?
 24)  How do I change the keyboard auto-repeat rate?
 25)  How do I remap the keys on my keyboard to produce a string?
 26)  How do I make a screendump or print my application (including menus)?
 27)  How do I make a color PostScript screendump of the X display?
 28)  How do I make a screendump without having an X display?
 29)  How do I make a screendump including the X cursor?
 30)! How do I convert or view Mac/TIFF/GIF/Sun/PICT/img/FAX images in X?
 31)  Where can I get an X-based 3-D object viewer?
 32)  How can I change the titlebar of my terminal window?
 33)  Where can I find the xterm control sequences?
 34)  How can I use characters above ASCII 127 in xterm ?
 35)  Why are my xterm menus so small (sic) ?
 36)! How can I control the mouse with the keyboard?
 37)  How can I print the current X selection?
 38)  Where are the resources loaded from?
 39)  How does Xt use environment variables in loading resources?
 40)  How to I have xdm put a picture behind the log-in window?
 41)  Why isn't my PATH set when xdm runs my .xsession file?
 42)  How do I keep my $DISPLAY when I rlogin to another machine?
 43)  How can I design my own font?
 44)  Why does adding a font to the server not work (sic)?
 45)  How do I convert a ".snf" font back to ".bdf" font?
 46)  What is a general method of getting a font in usable format?
 47)  How do I use DECwindows fonts on my non-DECwindows server?
 48)  How do I get a font name from the structure?
 49)  How can I set backgroundPixmap in a defaults file? 
 50)  How can I make small multi-color pixmap images? (What is XPM?)
 51)  Why can't I override translations? Only the first item works. (sic)
 52)  How can I have a clock show different timezones?
 53)  I have xmh, but it doesn't work. Where can I get MH?
 54)  Why am I suddenly unable to connect to my Sun X server?  
 55)  Why don't the R5 PEX demos work on my mono screen?
 56)  How do I get my Sun Type-[45] keyboard fully supported by Xsun?
 57)  How do I report bugs in X?
 58)  Why do I get "Warning: Widget class version mismatch"?
 59)! Why does my SPARC 4 with the TCX fail? 
 60)  Why does my SPARC say "Mapping cg3c: No such device or address"?
 61)  Where can I find a dictionary server for xwebster?
 62)! What desktop managers are available?
 63)  How can I use a Web browser as a help system?
 64)+ How can I retrieve resource values from an application?
 65)  TOPIC: OBTAINING X AND RELATED SOFTWARE AND HARDWARE
 66)  Is X public-domain software?
 67)  How compatible are X11R3, R4, R5, R6? What changes are there?
 68)! What is Fresco? When is Fresco rumored to be available?
 69)  Does Fresco work with g++ 2.5.8?
 70)  What is Broadway? 
 71)  Where can I get X11R6.1 (source and/or binaries)?
 72)  Where can I get X11R6 (source and/or binaries)?
 73)  Where can I get X11R5 (source and/or binaries)?
 74)  Where can I get XDM's Wraphelp.c ?
 75)  Where can I get patches to X11? 
 76)  What is the xstuff mail-archive?
 77)  Where can I get OSF/Motif?
 78)  Does Motif work with X11R4? X11R5? X11R6?
 79)  Where can I get toolkits implementing OPEN LOOK?
 80)  Where can I get other X sources? (including R5 modifications)
 81)! Where can I get interesting widgets?
 82)  Where can I get a good file-selector widget?
 83)  Where can I find a hypertext widget in source code?
 84)  What widget is appropriate to use as a drawing canvas?
 85)  What is the current state of the world in X terminals?
 86)  Where can I get an X server with a touchscreen or lightpen?
 87)  Where can I get an X server on a PC (DOS or Unix)?
 88)  Where can I get an X server on a Macintosh running MacOS?
 89)  Where can I get X for the Amiga?
 90)  Where can I get a serial-based X server for connecting from home?
 91)  Where can I get a fast X server for a workstation?
 92)  Where can I get a server for my high-end Sun graphics board?
 93)  Where can I get an "X terminal" server for my low-end Sun 3/50?
 94)  What terminal emulators other than xterm are available?
 95)  Does xterm offer colored text or a blinking cursor?
 96)! Where can I get an X-based editor or word-processor?
 97)! Where can I get an X-based mailer?
 98)! Where can I get an X-based paint/draw program?
 99)  Where can I get an X-based plotting program?
100)! Where can I get an X-based graph-drawing program?
101)! Where can I get an X-based spreadsheet?
102)  Where can I get X-based project-management software?
103)! Where can I get an X-based PostScript previewer?
104)  Where can I get an X-based GKS package?
105)  Where can I get an X-based IRIS GL package?
106)  Where can I get an X-based OpenGL package?
107)  Where can I get an X-based PEX package?
108)  Where can I get an X-based TeX or DVI previewer?
109)  Where can I get an X-based troff previewer?
110)! Where can I get a WYSIWYG interface builder (or other shortcuts)?
111)  Where can I find X tools callable from shell scripts?
112)! Where can I get an X-based debugger?
113)  Is there a "pseudo-tty" or fake X display I can use?
114)! How can I "tee" an X program identically to several displays? 
115)! Can I use C++ with X11? Motif? XView?
116)  Where can I obtain alternate language bindings to X/Xt/Motif?
117)! Where can I obtain alternate X toolkits?
118)  TOPIC: BUILDING THE X DISTRIBUTION [topic needs updating to R6]
119)  What's a good source of information on configuring the X build?
120)  Why doesn't X11R6 work on Solaris with GCC 2.7.0?
121)  Why doesn't my Sun with a cg6 work with R5?
122)  What are these build problems with Solaris 2.5?
123)  Why doesn't my Sun with SunOS 4.1 know about _dlsym, etc.?
124)  What is this "_get_wmShellWidgetClass undefined" error?
125)  Why don't xterm or xinit work on Solaris 2.4?
126)  What's this problem with undefined _X symbols on SunOS 4.1.3?
127)  Why does cc get used when I build X11R5 with gcc?
128)  What are these I/O errors running X built with gcc?
129)  What are these problems compiling the X11R5 server on SunOS 4.1.1?
130)  Can OW 3.0 OLIT programs run with R5 Xt? (_XtQString undefined)
131)  How do I get around the SunOS 4.1 security hole?
132)  How do I get around the frame-buffer security hole?
133)  TOPIC: BUILDING X PROGRAMS 
134)  What is Imake?
135)  Where can I get imake?
136)  I have a program with an Imakefile but no Makefile. What to do?
137)  Why can't I link to the Xlib shape routines?
138)  What are these problems with "_XtInherit not found" on the Sun?
139)  TOPIC: PROGRAMMING PROBLEMS AND PUZZLES
140)  Why doesn't my program get the keystrokes I select for (sic)?
141)  How do I deiconify a window?
142)  How do I figure out what window manager is running?
143)  Is there a skeleton X program available?
144)  How can I incorporate an Xlib program in my Xt program?
145)  Why does XtGetValues not work for me (sic)?
146)  Why don't XtConfigureWidget/XtResizeWidget/XtMoveWidget work?
147)+ How do I check whether an Xt widget is still valid?
148)  Why can't I get data back in my callback procedure?
149)  Why isn't there an XtReparentWidget call like XReparentWindow?
150)  I'm writing a widget and can't use a float as a resource value.
151)  Is this a memory leak in the X11R4 XtDestroyWidget()?!
152)  Is this a memory leak in the X11R4 deletion of work procs?!
153)  Why does the process size of my X programs go up,up,up?
154)  Are callbacks guaranteed to be called in the order registered?
155)  Why doesn't XtDestroyWidget() actually destroy the widget?
156)  How can I open multiple displays with Xt? 
157)  How do I query the user synchronously using Xt?
158)  How do I determine the name of an existing widget?
159)  Why do I get a BadDrawable error drawing to XtWindow(widget)?
160)  Where can I get documentation on Xaw, the Athena widget set?
161)  What's the difference between actions and callbacks?
162)  How do I simulate a button press/release event for a widget?
163)  Can I make Xt or Xlib calls from a signal handler?
164)! What are these "Xlib: unexpected async reply" errors?
165)  What are these "Xlib sequence lost" errors?
166)  How can my Xt program handle socket, pipe, or file input?
167)  Why doesn't my Xt timer go off when it is supposed to (sic) ?
168)  What's this R6 error: X Toolkit Error: NULL ArgVal in XtGetValues?
169)  Why do I get a BadMatch error when calling XGetImage?
170)  How can my application tell if it is being run under X?
171)  How do I make a "busy cursor" while my application is computing?
172)  How do I fork without hanging my parent X program?
173)  Why doesn't anything appear when I run this simple program?
174)  What is the difference between a Screen and a screen?
175)  Can XGetWindowAttributes get a window's background pixel/pixmap?
176)  How do I create a transparent window?
177)  Why doesn't GXxor produce mathematically-correct color values?
178)  Why does every color I allocate show up as black?
179)  Why do I get a protocol error when creating a cursor (sic)?
180)  Why can't my program get a standard colormap?
181)  Why doesn't the shared-memory extension appear to work?
182)  Why does the pixmap I copy to the screen show up as garbage? 
183)  How do I get the width/height of an existing pixmap?
184)  How can I most quickly send an image to the X server? 
185)  How do I check whether a window ID is valid?
186)  Can I have two applications draw to the same window?
187)  Why can't my program work with tvtwm or swm?
188)  Can I rely on a server which offers backing store?  
189)  How do I catch the "close window" event to avoid "fatal IO error"?
190)  How do I keep a window from being resized by the user?
191)  How do I keep a window in the foreground at all times?
192)  How do I make text and bitmaps blink in X?
193)  How do I get a double-click in Xlib?
194)  How do I render rotated text?
195)  Why doesn't my multi-threaded X program work (sic) ? 
196)  How can I ensure that only one instance of my application is running?
197)  How can I have two applications communicate via the X server?
198)  Where can I get information on internationalizing applications?
199)  What is the X Registry? (How do I reserve names?)

If you have suggestions or corrections for any of these answers or any 
additional information, please send them directly to uunet!craft!faq;
the information will be included in the next revision (or possibly the one 
after that; thanks for the many suggestions which haven't been incorporated 
yet). 

This version of the FAQ is in the process of having outdated information 
replaced by R6 information.

This posting is intended to be distributed monthly.  New versions are
archived on ftp.x.org (in contrib/faqs) and rtfm.mit.edu and are also
available from [email-masked] and [email-masked]
(send "help"). HTML versions seem to be at
http://www.cis.ohio-state.edu/hypertext/faq/usenet/x-faq/top.html.

ftp.x.org was previously known as export.lcs.mit.edu; x.org was previously 
known as expo.lcs.mit.edu. The general WWW server for the X Consortium is
http://www.x.org/.

The information contained herein has been gathered from a variety of sources. 
In many cases attribution has been lost; if you would like to claim 
responsibility for a particular item, please let me know. 

Conventions used below: telephone numbers tend to be Bell-system unless 
otherwise noted; prices on items are not included; email addresses are those
that work from the US.

X Window System and Fresco are trademarks of X Consortium, Inc.  Other
trademarks are the property of their respective owners.

This posting is copyright (c) 1996 by David B. Lewis, USA. All rights
reserved. Permission is hereby granted to read and distribute this posting
for non-commercial purposes.  Permission to use this material for any other
purpose must first be obtained in writing from the author.

----------------------------------------------------------------------
Subject:   0)  TOPIC: BASIC INFORMATION SOURCES AND DEFINITIONS
----------------------------------------------------------------------
Subject:   1)  What books and articles on X are good for beginners?

A bibliography containing cites of all known reference books and how-to
manuals and also cites of selected technical articles on X and X programming
is regularly posted to comp.windows.x; it is ftp-able as
	ftp.x.org:/contrib/docs/Xbibliography.ps 
	gatekeeper.dec.com:/pub/X11/R5-contrib/Xbibliography. 
	landru.unx.com:/pub/X11/
The current maintainer is Steve Mikes, [email-masked] 
([email-masked]).

Here is an unordered set of the reference books and tutorials most useful for
beginners; most appear on that list [comments are gathered from a variety of 
places and are unattributable]:

Asente, Paul J., and Swick, Ralph R., "X Window System Toolkit, The Complete
Programmer's Guide and Specification", Digital Press, 1990.  The bible on Xt.
A treasury of information, excellent and invaluable.  Distributed by Digital
Press, ISBN 1-55558-051-3, order number EY-E757E-DP; and by Prentice-Hall,
ISBN 0-13-972191-6. Also available through DEC Direct at 1-800-DIGITAL.  [The
examples are on ftp.x.org in R5contrib/ as asente-swick.examples.tar.Z.  They
were also posted to comp.sources.x as xt-examples/part0[1-5].]

Jones, Oliver, Introduction to the X Window System, Prentice-Hall, 1988,
1989.  ISBN 0-13-499997-5. An excellent introduction to programming with
Xlib.  Written with the programmer in mind, this book includes many practical
tips that are not found anywhere else. This book is not as broad as the
O'Reilly Xlib tutorial, but Jones is an experienced X programmer and this
shows in the quality and depth of the material in the book.

Young, Doug. "The X Window System: Applications and Programming with Xt
(Motif Version)," Prentice Hall, 1989 (ISBN 0-13-497074-8). The excellent
tutorial "X Window System Programming and Applications with Xt," (ISBN
0-13-972167-3) updated for Motif. Sources are on ftp.x.org in
R5contrib/young.tar.Z.  A Motif 1.2 version of this book is also out; see
ftp.x.org in contrib/book_examples/young.motif2.tar.Z.

Young, Doug and John Pew, "The X Window System: Programming and Applications
with Xt, OPEN LOOK Edition" (ISBN 0-13-982992-X). The tutorial rewritten for
OLIT, with new examples and drag/drop information. [Examples are in your
OpenWindows 3 distribution in $OPENWINHOME/share/src/olit/olitbook.]

Heller, Dan and Paula Ferguson. "Motif Programmers Manual".  The 6th volume
in the O'Reilly series covers application programming with Motif 1.2 and
earlier, including UIL; it's full of good examples (ISBN 1-56592-016-3).
Volume 6B is a reference book on Motif and UIL (ISBN ISBN 1-56592-038-4).
[The examples are available on uunet in the nutshell archives.]

Scheifler, Robert, and James Gettys, with Jim Flowers and David Rosenthal, "X
Window System: The Complete Reference to Xlib, X Protocol, ICCCM, XLFD, X
Version 11, Release 5, Third Edition," Digital Press, 1992. "The Bible" in
its latest revision, an enhanced version of X documentation by the authors of
the Xlib documentation. This is the most complete published description of
the X programming interface and X protocol. It is the primary reference work
and is not introductory tutorial documentation; additional tutorial works
will usually be needed by most new X programmers.  Digital Press order
EY-J802E-DP, ISBN 0-13-971201-1.

Nye, Adrian, "Xlib Programming Manual, Volume 1" and "Xlib Reference Manual,
Volume 2," O'Reilly and Associates.  The first volume is a tutorial with
broad coverage of Xlib, and the second contains reference pages for Xlib
functions and many useful reference appendices.  Both cover X11R5 (and R4).
ISBN 0-937175-26-9 (volume 1) and ISBN 0-937175-27-7 (volume 2).

Nye, Adrian, and Tim O'Reilly, "X Toolkit Programming Manual, Volume 4,"
O'Reilly and Associates, 1989, 1992. The folks at O'Reilly give their
comprehensive treatment to programming with the Xt Intrinsics, using the
Athena widgets in the examples; R5 versions are now available, as is a Motif
1.2 version (Volume 4M).

O'Reilly, Tim, ed.,  "X Toolkit Reference Manual, Volume 5," O'Reilly and
Associates. A professional reference manual for the X11R5 and X11R4 Xt.

Mansfield, Niall. "The X Window System: A User's Guide," Addison-Wesley,
1989.  A tutorial introduction to using X, now upgraded for R4. ISBN
0-201-51341-2.

Quercia, Valerie and Tim O'Reilly. "X Window System User's Guide," O'Reilly
and Associates. A tutorial introduction to using X. ISBN 0-937175-36-6.  
Covers R5; available in Athena and Motif editions.

Mui, Linda and Eric Pearce. "X Window System Administrator's Guide for X11 R4
and R5" [ORA Volume 8]. Help for X users and administrators.  ISBN
0-937175-83-8.

Drafts of John Ousterhout's book on TCL/TK are on sprite.berkeley.edu
(128.32.150.27) in /tcl. The final book was published by Addison-Wesley, ISBN
#0-201-63337-X.

(Prentice-Hall ordering is 201-767-5937. O'Reilly ordering is 800-998-9938
or 707-829-0515; ORA may also be contacted via email at [email-masked] or by
logging into gopher.ora.com as gopher.)

In addition, check the X11R4 and X11R5 core distribution in doc/tutorials for
some useful papers and tutorials, particularly the file answers.txt.  "Late
Night's Top Ten X11 Questions" by Dave Lemke ([email-masked]) and Stuart Marks
([email-masked]) answers other common questions and some of these here in
more detail.

A single volume, "Programmer's Supplement for R5" by David Flanagan, provides
an overview of new R5 features; it includes man pages for Xlib, Xt, and Xmu.
As of 10/93, its contents have been merged into other O'Reilly volumes, and
it is out of print.  [ISBN 0-937175-86-2]

----------------------------------------------------------------------
Subject:   2)  What courses on X and various X toolkits are available?

An on-line WWW X course is at
	http://www.cs.curtin.edu.au/units/cg252-502/src/notes/html/

Another is at:
	http://www.cms.dmu.ac.uk:80/~aug/FastTrack/

Motif tutorials are at:
	http://www.iftech.com

AT&T offers training in Xlib and in the Xol set. Contact AT&T Corporate
Education & Training for more info; 1-800-TRAINER in the USA.

BIM Educational Services offers training in X administration and in
programming with Xt/Motif and Open Windows; the courses are given near
Brussels. Info: [email-masked], voice +32-(0)2-7595925, fax +32-(0)2-7599209.

Bluestone Consulting, Inc. offers several multi-day, hands-on training
courses in X, Xt, Motif, C, C++, and UIM/X.  Information is available at
609-727-4600 or [email-masked].

Communica Software Consultants offers three-day hands-on courses in X
designed for the X Window System developer and programmer. Contact Chris
Clarkson, telephone 61 8 3732523, e-mail [email-masked]. [12/92]

Cora Computer Technologies (516-485-7343) offers several courses.

GHCT offers a one week lecture/lab course for programmers designed by Douglas
Young based on his book "The X Window System: Programming and Applications
with Xt, OSF/Motif Edition". Information: Brian Stell (415-966-8805 or
[email-masked]).

GHG offers a range of courses on X and Motif. Information:  713-488-8806 or
[email-masked].

Hands On Learning has live training and self-paced video workshops on topics
such as using and/or programming X, Xlib, Xm, and Xt.  Information:
617-272-0088, 800-248-9133.

Hewlett-Packard (1-800-HPCLASS; or contact your local HP center) offers a
2-day "Introduction to X", a 5-day Xlib course, a 1-day Xt and Motif 1.1
seminar, and a 5-day Motif lab course.

Integrated Computer Solutions, Inc., offers several multi-day, hands-on
courses on X, Xt, and the Xaw and Motif widget sets, in particular.
Information is available at 617-621-0060 and [email-masked].

Intelligent Visual Computing teaches several lab courses on-site for Motif
and XView. IVC is at 1-800-776-2810 or +1 919-481-1353 or at [email-masked].

Iris Computing Laboratories offers five-day Xlib and Xt courses.  Info:
+1-505-988-2670 or [email-masked].

IXI Limited (+44 223 462 131) offers regular X training courses for both
programmers and non-technical managers. See also: Unipalm, below.

Learning Tree International offers a four-day course in X Window System
applications development, including Xlib and some information on Motif.  For
more info call 800-824-9155 (213-417-3484); 613-748-7741 in Canada. Courses
are offered in major North American cities; also in London, Stockholm, Tokyo,
and elsewhere.

Lurnix offers several 3- to 5-day courses on using X and programming with
Xlib and Motif. Information is available at 800-875-4478.

Non Standard Logics (+33 (1) 43 36 77 50; [email-masked]) offers courses on
programming with Xlib, Motif, and creating Motif widgets.

OSF Educational Services (617-621-8778) offers one-day seminars and one-week
Motif lab courses.

John A. Pew offers a 5-day course on OLIT, possibly based on his book on that
subject; 408-224-5739.

SCO (+44 923 816344, [email-masked]) offers training for its Open Desktop
(Motif) environment in the UK and Europe.

Software Pundits (617-270-0639) offers a range of courses.

Technology Exchange (617-944-3700) offers a 4-day Xlib/Xt/Motif course.

Alsys (formerly TeleSoft) is now offering a 1-day plus 3-day seminar on X and
Motif.  Information: Bruce Sherman (619-457-2700, [email-masked]).

Unipalm XTech offers OSF's 5-day Motif course and a 1-day overview on X.
Information: Unipalm Training at +44 952  211797, [email-masked].

The University of Edinburgh is developing a series of courses on X and
related topics primarily for non-profit-making training in academia but also
for commercial use. Information: Cliff Booth, Unipalm Ltd, phone +44 223
420002, fax +44 223 426868.

Various other vendors are also beginning to offer X training, usually
specific to a proprietary toolkit or to Xt and a proprietary widget set: DEC
is offering Xlib courses; Sun offers an XView course.

Various universities are offering short X courses or overviews: UCLA,
Dartmouth, University of Lowell, University of Canberra (within Australia:
062-522422), UC Santa Cruz Extension (408-281-4823, [email-masked]) ...

Among the best places to find courses are at the various Unix conferences --
Uniforum, Usenix, Unix Expo, the X Technical Conference, the ACM tutorial
weeks, &c.

In addition, the X Consortium posts approximately quarterly a list of
unendorsed speakers and consultants who can provide talks on a variety of X
topics.

----------------------------------------------------------------------
Subject:   3)  What conferences on X are coming up?

The fourth annual Tcl/Tk workshop, sponsored by the USENIX Association, was to
be held July 10-13, 1996 in Monterey, California, to bring together current
Tcl/Tk researchers and practitioners and to plan for future work.
Information:  USENIX Conference Office 22672 Lambert Street, Suite 613 Lake
Forest CA 92630 (714) 588-8649 Fax: (714) 588-9706 email:
[email-masked] URL: http://www.usenix.org

The European X User Group holds an annual conference which typically includes
includes paper presentations and a vendor exhibit; the conference is usually
held in October. Information:  EXUG '94, PO Box 458, Cambridge, CB4 4AA Tel:
0954 789095, Fax: 0954 781797, Email: [email-masked], WWW:
http://www.nads.de/EXUG/ .

The X Technical Conference includes tutorials and technical talks. It is now
held in February in San Jose, CA.  Registration information is available from
[email-masked], 617-374-1025.  Other information is typically on ftp.x.org
in /pub/DOCS/XConsortium/ (also available via http://www.x.org ).

The XWorld Conference and Exhibition includes tutorials, panels,
presentations and vendor exhibits. It is typically held in March in New York
City.  Information: SIGS Publication Group at 212-274-9135; information on
XWorld95 is available via
http://www.sigs.com/conferences/xw95/xw95main.html .

The Motif/CDE show is held each year in Washington, DC, around the time of 
FedUnix. It offers courses, tutorials and paper presentations.  Information:
+1 301-596-8800, fax +1 301-596-8803, http://www.mcsp.com/OSW-FedUNIX .
Registration material can be obtained from [email-masked].

The Xhibition conference is cancelled for 1996; no other plans have
been announced (by [email-masked]).

The Andrew Technical Conference was to be held September 21-22, 1995 in
Pittsburgh.  Info: http://www.cs.cmu.edu/~AUIS/cfp.html .

Other trade shows -- UnixExpo, Uniforum, Siggraph -- show an increasing
presence of X, including tutorials and exhibits.

----------------------------------------------------------------------
Subject:   4)! What X-related public mailing lists are available?

The xpert mailing list is the general, public mailing list on X maintained by
the X Consortium. The mailings are gatewayed, so xpert is almost identical to
the comp.windows.x Usenet newsgroup.

	***     If you get comp.windows.x, you don't need to    *** 
	*** 	be added to the xpert mailing list.             ***

Otherwise, you can join the list to receive X information electronically. It
is best to find a local distribution; perhaps someone within your company is
already receiving the mailing. As a last resort, send mail to
[email-masked] with a valid return electronic address.

The xannounce mailing list carries major X announcements, such as new
releases (including public patches from the Consortium), public reviews,
adoption of standards by the X Consortium, and conference announcements.  It
does NOT carry advertisements, source code, patches, or questions.  If you
already receive the Usenet news group comp.windows.x.announce or the xpert
mailing list, you don't need to be added to the xannounce mailing list.
Otherwise, to subscribe, send a request to [email-masked]. Note:
only redistribution addresses will be accepted for this list -- i.e. no
personal addresses. If you wish to receive xannounce yourself, please contact
your mail administrator to set up a local redistribution list and to put you
on it.

comp.windows.x.apps is not gatewayed to a mailing list.

In addition, the X Consortium sponsors these public lists:
		bug-clx         CLX bug reports and discussions
		x-ada           X and ada 
		x11-3d          X and 3d graphics 
		ximage          image processing and X 
		xvideo          discussion of video extensions for X 
		x-agent		protocols for external agents (e.g. editres) 

To subscribe to any of the above mailing lists, send mail to the list with
"-request" appended; this example adds [email-masked] to the xpert
mailing list:

	% mail [email-masked]
	Subject: (none needed)
	subscribe xpert [email-masked]
	^D

To unsubscribe:

	% mail [email-masked]
	Subject: (none needed)
	unsubscribe
	^D

The Fresco list was made public 3/94; send to "[email-masked]" a message
containing "subscribe fresco <address>".

Other lists include:

A mailing list discussing the Andrew User Interface System (formerly Andrew
Toolkit) is maintained by the Andrew Consortium.  To subscribe, write to
[email-masked] and specify whether you want messages in
Andrew format or ASCII.  The ASCII versions are copied to netnews group
comp.soft-sys.andrew.

A mailing list discussing the TeleUSE builder can be subscribed to by sending
a request to [email-masked].

A mailing list discussing the UIM/X builder can be subscribed to by sending a
subject line of "subscribe" to [email-masked].

A mailing list to address issues of using Motif on Sun workstations is
sponsored by Freedom Software at [email-masked].

A mailing list for the Motif-C++ bindings is sponsored by Ronald van Loon;
subscribe to [email-masked].

A mailing list for topics related to the XPM pixmap-format is sponsored by
Arnaud Le Hors, now of the X Consortium; send to
[email-masked] for information.

A mailing list for SUIT users is available from
[email-masked]. (This group is gatewayed to
the newsgroup comp.windows.suit.)

A mailing list for imake users is available by sending "subscribe imake-talk"
to [email-masked].

A mailing list for topics related to Motif is available by sending subscribe
requests to [email-masked]. (This group is gatewayed to the
newsgroup comp.windows.x.motif.)

A mailing list ([email-masked]) for topics related to the port of X11
to the Amiga can be subscribed by sending to [email-masked] a
message containing
		Subject: Adding myself to AMIGA-X11 
		SUBS AMIGA-X11 Your Real Name 

A mailing list for MetaCard users is available by sending to
[email-masked] a message containing
		subscribe metacard-list firstname lastname 
		quit

A mailing list for Wafe users is available by sending to 
[email-masked] a message containing
		subscribe Wafe <Your Name>
		help

A mailing list discussing the fvwm window manager can be subscribed to
by sending to [email-masked] a message containing
		subscribe fvwm

A mailing list discussing the xemacs editor can be subscribed to by sending a
request to [email-masked].

----------------------------------------------------------------------
Subject:   5)  How can I meet other X developers? (What X user groups are there?)

O'Reilly and Associates sponsors a mailing list for the use of X user group
organizers; subscribe by sending to [email-masked] the message "subscribe
xgroups [email-masked]".

Local area X user's groups are listed in Issue 4 of O'Reilly's X Resource
journal.

The French X User Group is called AFUX and is based in Sophia Antipolis by
CERICS. Information can be obtained from Miss Vasseur or Miss Forest; BP 148;
157, rue Albert Einstein; 06561 Valbonne Cedex; Phone:  +33 93 95 45 00 / 45
01; Fax: +33 93 95 48 57.  [10/90]

The European X User Group was formed in 1989 to represent X users in Europe.
It holds technical conferences at regular intervals. The EXUG also publishes
a regular newsletter which is distributed free of charge to members.  The
EXUG also runs a email mailing list for members which is frequently used to
address issues of European interest in X. Info:  Tel: +44 (0) 954 789095;
Fax: +44 (0) 954 781797; Email: [email-masked]; WWW:
http://www.nads.de/EXUG/ .

----------------------------------------------------------------------
Subject:   6)  What related FAQs are available?

This is the general comp.windows.x FAQ. Most FAQs are on rtfm.mit.edu; the
ones mentioned below are typically also on ftp.x.org in contrib/faqs/.

Liam R. E. Quin ([email-masked]) posts a FAQ on Open Look to
comp.windows.open-look.

Ken Sall ([email-masked]) posts a FAQ on Motif to comp.windows.x.motif; the
Motif WEB page is at http://www.cen.com/mw3/ .

Peter Ware ([email-masked]) posts a FAQ to comp.windows.x.intrinsics.

Art Mulder ([email-masked]) posts to comp.windows.x a FAQ on maximizing
the performance of X.

Steve Kotsopoulos ([email-masked]) posts to comp.windows.x a FAQ about
using X on Intel-based Unix systems.

Justin Kibell ([email-masked]) posts to comp.windows.x a FAQ on games for
X.

Luis Fernandes ([email-masked]) posts to comp.windows.x.apps a FAQ on X
applications; see also http://www.ee.ryerson.ca/~elf/xapps/faq.html .

John Cwikla ([email-masked]) posts to comp.windows.x.intrinsics a FAQ on
available widgets. See also http://www.wri.com/~cwikla/widget/ and Xlopedia 
there.

Ross McKay ([email-masked]) posts to comp.windows.misc a FAQ which
includes information on platform-independent GUI (PIGUI) development kits.

Pete Phillips ([email-masked]) posts to comp.sources.wanted a FAQ on
project-management programs.

Wade Guthrie ([email-masked]) posts to comp.windows.misc a FAQ on 
platform-independent GUI toolkits (PIGUI).

Craig Prall ([email-masked]) posts to alt.windows.cde a FAQ on the CDE 
environment (and the COSE initiative).

The FAQ in alt.binaries.pictures contains information on viewing images with
X and on massaging image formats.

The FAQ in comp.mail.mh (gatewayed to [email-masked]) includes a
section on xmh.

The FAQ in comp.lang.lisp contains information on several interface tools and
toolkits.

The FAQ for the Andrew User Interface System is available for ftp from
ftp.andrew.cmu.edu (128.2.232.154).

The FAQ list for comp.lang.tcl details information on particular tcl/TK-based
packages and related mailing lists.

----------------------------------------------------------------------
Subject:   7)  How do I ask a net-question so as to maximize helpful responses?

When asking for help on the net or X mailing lists, be sure to include all
information about your setup and what you are doing.  The more specific you
are, the more likely someone will spot an error in what you are doing.
Without all the details, people who want to help you often have to guess --
if they are able to respond at all.

Always mention what version of X you are using and where you got it from. If
your server came from a different source as the rest of your X system, give
details of that, too.  Give the machine type, operating system, and O/S
version for both the client and server machine.  It may also be appropriate
to mention the window manager, compiler, and display hardware type you are
using.

Then tell exactly what you are doing, exactly what happens, and what you
expected/wanted to happen.  If it is a command that fails, include the exact
transcript of your session in the message.  If a program you wrote doesn't
work the way you expect, include as little of the source necessary (just a
small test case, please!) for readers to reproduce the problem.

----------------------------------------------------------------------
Subject:   8)! What publications discussing X are available?

The trade magazines (Unix World, Unix Review, etc.) are publishing more
articles on X. Three X-specific publications include:

The X Journal is a bi-monthly publication on a variety of X topics,
publishing through 12/96.  Subscription information: The X Journal,
Subscriber Services, PO Box 5050, Brentwood, TN 37024-5050, 1-800-361-1279,
[email-masked], http://www.sigs.com .  Editorial information:
Charles F. Bowman, Editor-in-Chief, The X Journal, 71 West 23rd Street, New
York, NY 10012, [email-masked].

The X Advisor is a free on-line publication. You can view it at
http://landru.unx.com/ .

----------------------------------------------------------------------
Subject:   9)  What are these common abbreviations/acronyms?

Xt: The X Toolkit Intrinsics is a library layered on Xlib which provides the
functionality from which the widget sets are built. An "Xt-based" program is
an application which uses one of those widget sets and which uses Intrinsics
mechanisms to manipulate the widgets.

Xmu: The Xmu library is a collection of Miscellaneous Utility functions
useful in building various applications and widgets.

Xaw: The Athena Widget Set is the Consortium-implemented sample widget set
distributed with X11 source.

Xm: The OSF/Motif widget set from the Open Software Foundation; binary kits
are available from many hardware vendors.

Xhp (Xw): The Hewlett-Packard Widget Set was originally based on R2++, but
several sets of patches exist which bring it up to R3, as it is distributed
on the X11R4 tapes. Supplemental patches are available to use it with R4 and
later.

CLX: The Common Lisp X Interface is a Common Lisp equivalent to Xlib.

XDMCP: The X Display Manager Protocol provides a uniform mechanism for a
display such as an X terminal to request login service from a remote host.

XLFD: The X Logical Font Description Conventions describes a standard logical
font description and conventions to be used by clients so that they can query
and access those resources.

RTFM: Common expert-speak meaning "please locate and consult the relevant
documentation -- Read the Forgotten Manual".

UTSL: A common expression meaning "take advantage of the fact that you aren't
limited by a binary license -- Use The Source, Luke".

API: Application-Programmer Interface. The function calls, etc., in a
programming library.

BDF: Bitmap Distribution Format; a human-readable format for uncompiled X
fonts.

GUI: graphical user interface.  

UIL: the User Interface Language, part of OSF/Motif which lets programmers
specify a widget hierarchy in a simple text "outline" form

WCL: the Widget Creation Language, a package which extends the understanding
of the Xt resource format such that a widget hierarchy and actions on the
widgets can be specified through the resources file

UIMS: User Interface Management System

----------------------------------------------------------------------
Subject:  10)  What is the ICCCM? (How do I write X-friendly applications?)

	The Inter-Client Communication Conventions Manual is one of the
official X Consortium standards documents that define the X environment. It
describes the conventions that clients must observe to coexist peacefully
with other clients sharing the same server.  If you are writing X clients,
you need to read and understand the ICCCM, in particular the sections
discussing the selection mechanism and the interaction between your client
and the window manager.

	Alternate definition: the ICCCM is generally the M in "RTFM" and is
the most-important of the least-read X documents.

Get the ICCCM from these sources:

	- Version 2.0 of the ICCCM is an X Consortium standard as of R6.  See
xc/doc/specs/ICCCM in the R6 distribution.

Older versions include: 

	- as part of the R5 and R4 distribution 
	- in the later editions of the Scheifler/Gettys "X Window System" book 
	- as an appendix in the new version of O'Reilly's Volume 0, "X
Protocol Reference Manual." A version in old copies of ORA Volume 1 is
obsolete.  The version in the Digital Press book is much more readable,
thanks to the efforts of Digital Press's editors to improve the English and
the presentation.  [from David Rosenthal, 10/90]

----------------------------------------------------------------------
Subject:  11)  What is the X Consortium, and how do I join?

The X Consortium was formed in January of 1988 to further the development of
the X Window System and has as its major goal the promotion of cooperation
within the computer industry in the creation of standard software interfaces
at all layers in the X Window System environment. MIT for many years provided
the vendor-neutral architectural and administrative leadership required to
make the organization work. The X Consortium is now an independent
consortium.

Most of the Consortium's activities take place via electronic mail, with
meetings when required.  As designs and specifications take shape, interest
groups are formed from experts in the participating organizations.  Typically
a small multi-organization architecture team leads the design, with others
acting as close observers and reviewers.  Once a complete specification is
produced, it may be submitted for formal technical review by the Consortium
as a proposed standard.  The standards process typically includes public
review (outside the Consortium) and a demonstration of proof of concept.

Your involvement in the public review process or as a member of the
Consortium is welcomed. Membership in the Consortium open to any
organization; there are several membership categories.  Write to Bob
Scheifler, President, X Consortium, One Memorial Drive, Cambridge, MA
02142-1301, or send a message to [email-masked], or look in
/pub/DOCS/XConsortium on ftp.x.org, or use the URL
http://www.x.org/ftp/pub/DOCS/XConsortium .

[2/90; 9/93; 12/93; 5/94]

----------------------------------------------------------------------
Subject:  12)  Just what are OPEN LOOK and Motif?

OPEN LOOK and Motif are two graphical user interfaces (GUIs). OPEN LOOK was
developed by Sun with help from AT&T and many industry reviewers; Motif was
developed by the Open Software Foundation (OSF) with input from many OSF
members.

OPEN LOOK is primarily a user-interface specification and style-guide; there
are several toolkits which can be used to produce OPEN LOOK applications.
Motif includes an API specification; the only sanctioned Motif toolkit is the
one from OSF. However, there are other toolkits which can be used to produce
programs which look and behave like OSF/Motif; one of these, Pure's (formerly
ParcPlace's; formerly Solbourne's) OI, is a "virtual toolkit" which provides
objects in the style of OPEN LOOK and Motif, at the user's choice.

OPEN LOOK GUI is also the name of a product from AT&T, comprising their OPEN
LOOK Intrinsics Toolkit and a variety of applications.

[Thanks to Ian Darwin, [email-masked], 5/91]

With the recent COSE announcement it appears that Sun will be phasing out
support for OPEN LOOK in favor of Motif.

----------------------------------------------------------------------
Subject:  13)! What is "low-bandwidth X" (X.fast/LBX)? XRemote? PPP? SLIP? CSLIP?

X.fast is the new name of LBX.

The one-line summary of LBX is:
	LBX  =  "XRemote"  +  reply/event/error compaction  +  caching

There are several options for using X over serial lines:

SLIP - Serial Line IP; this is both a mechanism and a protocol for sending IP
packets over point-to-point serial links. It has been around for several
years, and implementations are available for many of the major TCP/IP
implementations.  Most X Terminal vendors supply this as a checkoff item,
although nobody really ever uses it since it is horribly slow.  The TCP/IP
headers add 40 bytes per packet and the TCP/IP encoding of the X protocol is
rather verbose (rightfully so; it is optimized for packing and unpacking over
high-speed links).

CSLIP - Compressed header SLIP; this is a variant of SLIP that compresses the
40 bytes of TCP/IP headers down to about 5 or 6 bytes.  It still doesn't do
anything about reencoding the X protocol.  Modems that do compression can
help, but they increase packet latency (it takes time to dribble the
uncompressed data through typical serial interfaces, plus the compression
assembly time).

PPP - Point-to-Point Protocol; this is an emerging standard for point-to-point
links over serial lines that has a more complete set of option negotiation
than SLIP.  A growing number of people see the combination of PPP for the
serial line management and CSLIP for the header compression as becoming common
for running normal TCP/IP protocols over serial lines.  Running raw X over the
wire still needs compression somewhere to make it usable.

XRemote - this is the name of both a protocol and set of products originally
developed by NCD for squeezing the X protocol over serial lines.  In addition
to using a low level transport mechanism similar to PPP/CSLIP, XRemote removes
redundancies in the X protocol by sending deltas against previous packets and
using LZW to compress the entire data stream.  This work is done by either a
pseudo-X server or "proxy" running on the host or in a terminal server.  There
are several advantages to doing compression outside the modem:
   (1)  You don't *have* to have compressing modems in there if you wouldn't
	otherwise be using them (e.g. if you were going to be directly
	connected), and 
   (2)  It reduces the I/O overhead by cutting down on the number of bytes 
	that have to cross the serial interface, and 
   (3)  In addition to the effects of #2, it reduces the latency in delivering
	packets by not requiring the modem to buffer up the data waiting for
	blocks to compress.

LBX - Low Bandwidth X; this is an X Consortium project that is working on a
standard for this area.  It is being chaired by NCD and Xerox and is using
NCD's XRemote protocol as a stepping stone in developing the new protocol.
LBX will go beyond XRemote by adding proxy caching of commonly-used
information (e.g. connection setup data, large window properties, font
metrics, keymaps, etc.) and a more efficient encoding of the X protocol. The
hope is to have a Standard ready for public review in the first half of next
year and a sample implementation available in R6.

Additional technical information about how XRemote works and a few notes on
how LBX might be different are available via anonymous ftp from ftp.x.org in
R5contrib/ in the following files:
	XRemote-slides.ps               slides describing XRemote
	XRemote-LBX-diffs.ps            more slides describing some of LBX

[information provided by Jim Fulton, [email-masked]; 7/92]

There is also a set of slides on ftp.x.org from Jim Fulton's talk at the 7th
X Technical Conference.

LBX is designated as a work in progress in R6.  See workInProgress/README and
workInProgress/lbx/README in the R6 distribution for more information.

LBX was withdrawn from the X11R6.1 release until it can be finished. It is
being worked on within the X Consortium and is intended to be released as a
Consortium standard, with a Consortium implementation, as part of Broadway.
[3/96]

Note: dxpc is an X11 compressor that improves the performance of X
applications run over low-bandwidth network connections (e.g. 28.8Kb/s).  It
runs on most UNIXes.  dxpc achieves compression performance between
3:1 and 6:1 compression for a wide variety of applications.  Sources are on
ftp://sunsite.unc.edu/pub/Linux/X11/xutils/dxpc-3.3.0.tar.gz and
ftp://ftp.x.org/contrib/utilities/dxpc-3.3.0.tar.gz .  Information: Brian Pane
([email-masked]) [9/96]

Note: X/lbX/server is the implementation of the server side of the X11R6 LBX
"protocol", totally independent from the X Window server. It is an LBX proxy
for the client side containing some performance enhancements and bug fixes.
You may use any X Consortium LBX proxy, too. The software is in beta state.
See http://www.x-software.com/Software/Xlbx/ for more information. [8/96]

----------------------------------------------------------------------
Subject:  14)+ TOPIC: X CONSORTIUM FUTURES
----------------------------------------------------------------------
Subject:  15)+ What's the official word from the X Consortium?

Here is the text of the announcement posted by the Consortium to 
comp.windows.x on 1 July 1996:

     X Consortium to Transfer X Window System(tm) to The Open Group

Cambridge, Massachusetts - July 1, 1996 - X Consortium, Inc. today
announced that it would transfer responsibility for the X Window System
to The Open Group at the beginning of next year. "X is now mainstream
technology, and since the first commercial release in 1986 it has
matured to the point where a dedicated consortium is no longer essential
to its on-going support," explains Robert W. Scheifler, president of the
X Consortium. "Our industry will benefit greatly by continuing and
accelerating the convergence of X, Motif and the Common Desktop
Environment (CDE) into a unified technology stack. This is already well
underway with the current CDE-Motif PST project, operating under the
auspices of The Open Group, an organization that is well positioned to
take this technology into the future."  The Open Group will continue
their existing work of publishing, testing and branding products which
conform to international standards, including X.

"As a long standing partner with the X Consortium in the Open Systems
industry, The Open Group supports this decision. On a personal note, I
want to add that the computer industry owes an enormous debt of
gratitude to Bob Scheifler and the X Consortium for the service they
have provided for the last eight years," commented Jim Bell, CEO of The
Open Group. "Their very positive impact on our industry will continue to
be felt for years to come."

As part of this change, X Consortium plans to wind down all engineering
operations at the end of this year. "I have made a commitment to our
members, and to the sponsors of the CDE-Motif project, to oversee the
entire transition process from now until our current engineering
projects are finished and the hand-off is complete," said Scheifler. The
X Consortium will work with its members and The Open Group to determine
whether the organization should continue on in some reduced fashion.

Broadway, the code name for the next release of the X Window System,
will be completed as planned by the end of the year, and will be made
freely available to the public under the same terms as previous X
Consortium releases.  Broadway enables interactive UNIX and Windows
applications to be integrated, unmodified, into HTML documents and
published on World Wide Web servers, using plug-in technology, and
includes network protocols for graphics and audio to provide remote
access to those applications from inside Web browsers. The Broadway
release is expected to be available from current sources, including
worldwide ftp sites and CDROM distributors.

The X Consortium will fulfill its obligations as prime contractor in The
Open Group's Pre-Structured Technology (PST) project developing the next
release of CDE and Motif. "The plan has always been to complete both the
CDE-Motif project and Broadway by the end of this year," says Jim
Fournier, Director of Engineering. "We are confident in our ability to
deliver as planned."

About the X Consortium

Headquartered in Cambridge, Massachusetts, X Consortium, Inc. is a
not-for-profit industry consortium developing user interface standards
and graphics technology with over sixty members worldwide. Founded in
1993 as successor to the MIT X Consortium, the X Consortium enhances and
maintains the X Window System. In 1995, the X Consortium was named prime
contractor for development of the next release of CDE and Motif.

X Window System is a trademark of X Consortium, Inc.
Motif is a registered trademark of the Open Software Foundation, Inc.
The Open Group is a trademark of the Open Software Foundation, Inc. and
X/Open Company Ltd.  
All other trademarks mentioned are the property of their respective owners.

----------------------------------------------------------------------
Subject:  16)+ What happens to X? to Broadway? still free?

Broadway, which will be named an X11 release when done, will be available
under the same terms X has always been available under.  What happens after
that, and the terms under which any potential future developments will be
made available, is still under discussion.

The fact that Motif, CDE, and X are now hosted by the same organization doesn't
imply that Motif becomes free software, nor that X becomes licensed software.

----------------------------------------------------------------------
Subject:  17)+ Why is this happening?

What's happened is a recognition that the original mission of the X
Consortium is largely complete, and that a full-fledged industry Consortium
isn't really needed or even necessarily appropriate for ongoing maintenance
of X.  Under those circumstances, it makes sense to bundle X in with the
other components of what has become the standard Unix desktop -- Motif and
CDE -- and turn the whole package over to OSF and X/Open (aka The Open Group)
for future maintenance.

[thanks to Matt Landau ([email-masked])]

----------------------------------------------------------------------

David B. Lewis 					[email-masked]

		"Just the FAQs, ma'am." -- Joe Friday